void RenderDisplay(CSceneVehicleVisState@ state) {
    CTrackMania@ app = cast<CTrackMania>(GetApp());
        if (app !is null) {
            auto playground = cast<CSmArenaClient>(app.CurrentPlayground);

            if (playground !is null && playground.Arena.Players.Length > 0) {
            auto script = cast<CSmScriptPlayer>(playground.Arena.Players[0].ScriptAPI);

            if (script !is null) {
                DrawReactorDingsBoms();
                
                float intensity = GetVignetteIntensity();
                DrawVignette(intensity, calculatedVignetteColor);


            }
        }
    }
}

void DrawReactorDingsBoms() {
    vec4 reactorGray = vec4(1, 1, 1, Tool_Opacity_Reactor);
    vec4 reactorGreen = vec4(0, 1, 0, Tool_Opacity_Reactor);
    vec4 reactorRed = vec4(1, 0, 0, Tool_Opacity_Reactor);

    if (ReactorLevel == ESceneVehicleVisReactorBoostLvl::None) {
        fillColor = reactorGray;
    }
    if (ReactorLevel == ESceneVehicleVisReactorBoostLvl::Lvl1) {
        fillColor = reactorGreen;
    }
    if (ReactorLevel == ESceneVehicleVisReactorBoostLvl::Lvl2) {
        fillColor = reactorRed;
    }

    if (ReactorLevel != ESceneVehicleVisReactorBoostLvl::None) {
        vec2 pos;
        vec2 size;
        vec4 strokeColor;
        vec4 backgroundFillColor;
        vec2 sizeChange;
        vec2 startPos;

        if(currentDisplayMode == SIDE_LEFT)
        {
            pos = vec2(0, 293);
            size = vec2(300, 60);
            strokeColor = vec4(0, 0, 0, 0);
            backgroundFillColor = vec4(0, 0, 0, Tool_Opacity);

            float widthChange = 283 * (CountdownTime / 6000.0) - 1;
            sizeChange = vec2(widthChange, 40);

            startPos = vec2(7, 303);
        }
        else if(currentDisplayMode == MIDDLE) 
        {
            pos = vec2(1150, 293);
            size = vec2(60, 300);
            strokeColor = vec4(0, 0, 0, 0);
            backgroundFillColor = vec4(0, 0, 0, Tool_Opacity);

            float heightChange = 286 * (CountdownTime / 6000.0) - 1;
            sizeChange = vec2(46, heightChange);
            startPos = vec2(1157, 585 - heightChange);
        }
        else if(currentDisplayMode == TOP_MIDDLE)
        {
            float screenWidth = Draw::GetWidth();
            float elementWidth = 300;

            pos = vec2((screenWidth - elementWidth) / 2, 0);
            size = vec2(300, 60);
            strokeColor = vec4(0, 0, 0, 0);
            backgroundFillColor = vec4(0, 0, 0, Tool_Opacity + 0.3);

            float widthChange = 283 * (CountdownTime / 6000.0) - 1;
            sizeChange = vec2(widthChange, 40);
            startPos = vec2(pos.x + 9, Top_Middle_Height_Offset + 9);
        }
        else if (currentDisplayMode == TOP_MIDDLE_VERTICAL)
        {
            float screenWidth = Draw::GetWidth();
            float elementWidth = 60;

            pos = vec2((screenWidth - elementWidth) / 2, 0);
            size = vec2(60, 300);
            strokeColor = vec4(0, 0, 0, 0);
            backgroundFillColor = vec4(0, 0, 0, Tool_Opacity);

            float heightChange = 286 * (CountdownTime / 6000.0) - 1;
            sizeChange = vec2(46, heightChange);
            startPos = vec2((screenWidth - elementWidth) / 2 + 7, 300 - 8 - heightChange);
        }
        else if (currentDisplayMode == CUSTOM_SIZE_POSITION)
        {
            if (Sync_Background_Cooldown) {
                if (Force_Middle) {
                    float screenWidth = Draw::GetWidth();
                    float elementWidth = Custom_Width_Tool;
                    pos = vec2((screenWidth - elementWidth) / 2, Custom_Position_Y);
                } else {
                    pos = vec2(Custom_Position_X, Custom_Position_Y);
                }

                size = vec2(Custom_Width_Tool, Custom_Height_Tool);
                strokeColor = vec4(0, 0, 0, 0);
                backgroundFillColor = vec4(0, 0, 0, Tool_Opacity);

                float heightChange = Custom_Height_Tool_Cooldown * (CountdownTime / 6000.0) - 1;

                sizeChange = vec2(size.x - 14, heightChange);

                startPos = vec2(pos.x + 7, pos.y + size.y - sizeChange.y - 7);
            } else {
                if (Force_Middle) {
                    float screenWidth = Draw::GetWidth();
                    float elementWidth = Custom_Width_Tool;

                    pos = vec2((screenWidth - elementWidth) / 2, Custom_Position_Y);
                    size = vec2(Custom_Width_Tool, Custom_Height_Tool);
                    strokeColor = vec4(0, 0, 0, 0);
                    backgroundFillColor = vec4(0, 0, 0, Tool_Opacity);
                } else {
                    pos = vec2(Custom_Position_X, Custom_Position_Y);
                    size = vec2(Custom_Width_Tool, Custom_Height_Tool);
                    strokeColor = vec4(0, 0, 0, 0);
                    backgroundFillColor = vec4(0, 0, 0, Tool_Opacity);
                }

                float heightChange = Custom_Height_Tool_Cooldown * (CountdownTime / 6000.0) - 1;
                sizeChange = vec2(Custom_Width_Tool_Cooldown, heightChange);
                if (Force_Middle) {
                    float screenWidth = Draw::GetWidth();
                    float elementWidth = Custom_Width_Tool;
                    
                    startPos = vec2((screenWidth - elementWidth) / 2 + 7, Custom_Position_Y + Custom_Height_Tool - 8 - heightChange);
                } else {
                    startPos = vec2(Custom_Position_X + 7, Custom_Position_Y + Custom_Height_Tool - 8 - heightChange);
                }
            }
        }


        if (Sync_Background_Cooldown) {

            // BG
            nvg::BeginPath();
            nvg::Rect(pos, size);
            nvg::StrokeColor(strokeColor);
            nvg::FillColor(backgroundFillColor);
            nvg::Fill();
            nvg::Stroke();
            nvg::ClosePath();

            // Front
            nvg::BeginPath();
            nvg::Rect(startPos, sizeChange);
            nvg::StrokeColor(strokeColor);
            nvg::FillColor(fillColor);
            nvg::Fill();
            nvg::Stroke();
            nvg::ClosePath();

        } else {

            // BG
            nvg::BeginPath();
            nvg::Rect(pos, size);
            nvg::StrokeColor(strokeColor);
            nvg::FillColor(backgroundFillColor);
            nvg::Fill();
            nvg::Stroke();
            nvg::ClosePath();

            // Front
            nvg::BeginPath();
            nvg::Rect(startPos, sizeChange);
            nvg::StrokeColor(strokeColor);
            nvg::FillColor(fillColor);
            nvg::Fill();
            nvg::Stroke();
            nvg::ClosePath();
        }
    }
}

// pulse

vec4 calculatedVignetteColor;
float pxRatio = 1.0;

const float fadeDuration = 100.0;
const float fadeRate = 100.0 / fadeDuration;


void Update(float dt)
{
    if (Vignette_Opacity > 100.0) {
        Vignette_Opacity = 100.0;
    }

    if (Vignette_Color.x > 255.0) Vignette_Color.x = 255.0;
    if (Vignette_Color.y > 255.0) Vignette_Color.y = 255.0;
    if (Vignette_Color.z > 255.0) Vignette_Color.z = 255.0;
    
    calculatedVignetteColor = vec4(get_Normalized_Vignette_Color(), get_Normalized_Vignette_Opacity());

    if (Last_Pulse_Is_White && Enable_Final_Pulse__Vignette && CountdownTime >= 1 && CountdownTime <= 50) {
        calculatedVignetteColor = vec4(1, 1, 1, get_Normalized_Vignette_Opacity());
    }

    if (Use_Four_Pulses) {
        if ((CountdownTime >= 850 && CountdownTime <= 949) || 
            (CountdownTime >= 550 && CountdownTime <= 650) || 
            (CountdownTime >= 250 && CountdownTime <= 350) || 
            (Enable_Final_Pulse__Vignette && CountdownTime >= 1 && CountdownTime <= 100))
        {
            Vignette_Opacity -= fadeRate * dt;
            if (Vignette_Opacity < 0.0) {
                Vignette_Opacity = 0.0;
            }
        } else {
            Vignette_Opacity = User_Vignette_Opacity;
        }
    }
    else {
        if ((CountdownTime >= 850 && CountdownTime <= 949) || 
            (CountdownTime >= 450 && CountdownTime <= 550) || 
            (Enable_Final_Pulse__Vignette && CountdownTime >= 1 && CountdownTime <= 100))
        {
        Vignette_Opacity -= fadeRate * dt;
        if (Vignette_Opacity < 0.0) {
            Vignette_Opacity = 0.0;
        }
    } else {
        Vignette_Opacity = User_Vignette_Opacity;
    }
}


}

void Draw() 
{
    DrawVignette(GetVignetteIntensity(), calculatedVignetteColor);
}

void DrawVignette(float intensity, vec4 color)
{
    if (Use_Pule_Vignette) {
        float screenWidth = Draw::GetWidth();
        float screenHeight = Draw::GetHeight();
        vec2 center = vec2(screenWidth/2, screenHeight/2);
        float innerRadius = 0.9 * (screenWidth/2);
        float outerRadius = screenWidth/2;

        if (use_Default_Cooldown_Colors) {
            if (ReactorLevel == 1) {
                nvg::Paint paint = nvg::RadialGradient(center, innerRadius, outerRadius, vec4(0, 1, 0, 0), vec4(0, 1, 0, color.w * intensity));

                nvg::BeginPath();
                nvg::Rect(0, 0, screenWidth, screenHeight);
                nvg::FillPaint(paint);
                nvg::Fill();
                nvg::ClosePath();
            } else if (ReactorLevel == 2) {
                nvg::Paint paint = nvg::RadialGradient(center, innerRadius, outerRadius, vec4(1, 0, 0, 0), vec4(1, 0, 0, color.w * intensity));

                nvg::BeginPath();
                nvg::Rect(0, 0, screenWidth, screenHeight);
                nvg::FillPaint(paint);
                nvg::Fill();
                nvg::ClosePath();
            }
        } else {
            nvg::Paint paint = nvg::RadialGradient(center, innerRadius, outerRadius, vec4(0, 0, 0, 0), vec4(color.x, color.y, color.z, color.w * intensity));

            nvg::BeginPath();
            nvg::Rect(0, 0, screenWidth, screenHeight);
            nvg::FillPaint(paint);
            nvg::Fill();
            nvg::ClosePath();
        }
    }
}

float GetVignetteIntensity()
{
    if (Use_Four_Pulses) {
        if ((CountdownTime >= 850 && CountdownTime <= 949) || 
            (CountdownTime >= int(550) && CountdownTime <= int(650)) || 
            (CountdownTime >= int(250) && CountdownTime <= int(350)) || 
            (Enable_Final_Pulse__Vignette && CountdownTime >= 1 && CountdownTime <= 100))
        {
            return 1.0;
        }
        return 0.0;
    } else {
        if ((CountdownTime >= 850 && CountdownTime <= 949) || 
            (CountdownTime >= int(450) && CountdownTime <= int(550)) || 
            (Enable_Final_Pulse__Vignette && CountdownTime >= 1 && CountdownTime <= 100))
        {
            return 1.0;
        }
        return 0.0;
    }
}

float get_Normalized_Vignette_Opacity()
{
    return Vignette_Opacity / 100.0;

    if (Vignette_Opacity > 100.0) {
        Vignette_Opacity = 100.0;
    }
    return Vignette_Opacity / 100.0;
}

vec3 get_Normalized_Vignette_Color()
{
    vec3 normalizedColor;
    normalizedColor.x = (Vignette_Color.x > 255.0) ? 255.0 : Vignette_Color.x;
    normalizedColor.y = (Vignette_Color.y > 255.0) ? 255.0 : Vignette_Color.y;
    normalizedColor.z = (Vignette_Color.z > 255.0) ? 255.0 : Vignette_Color.z;

    return vec3(normalizedColor.x / 255.0, normalizedColor.y / 255.0, normalizedColor.z / 255.0);
}
















// COTD shit, I am done trying to get Textures from beond the hellscape only knows as texture loading...



/*
float COTD_Gradient_First_10_Persent_Intencity = 0.96;

void DrawLinearGradientsCOTD()
{
    float screenWidth = Draw::GetWidth();
    float screenHeight = Draw::GetHeight();

    vec4 color = vec4(get_Normalized_Color(COTD_Gradient_Color), get_Adjusted_Opacity(COTD_Gradient_First_10_Persent_Intencity));



    float solidEndPoint = screenWidth * 0.1;
    float fadeEndPoint = screenWidth * 0.5;

    vec4 solidColor = vec4(get_Normalized_Color(COTD_Gradient_Color), get_Adjusted_Opacity(COTD_Gradient_First_10_Persent_Intencity));
    nvg::Paint solidGradient = nvg::LinearGradient(vec2(0, screenHeight - 50), vec2(solidEndPoint, screenHeight - 50), 
                                                solidColor, solidColor);

    nvg::BeginPath();
    nvg::Rect(0, screenHeight - 50, solidEndPoint, screenHeight);
    nvg::FillPaint(solidGradient);
    nvg::Fill();
    nvg::ClosePath();

    vec4 fadingStartColor = vec4(get_Normalized_Color(COTD_Gradient_Color), get_Adjusted_Opacity(COTD_Gradient_First_10_Persent_Intencity));
    vec4 fadingEndColor = vec4(get_Normalized_Color(COTD_Gradient_Color), 0.0);
    nvg::Paint fadeGradient = nvg::LinearGradient(vec2(solidEndPoint, screenHeight - 50), vec2(fadeEndPoint, screenHeight - 50), 
                                                fadingStartColor, fadingEndColor);

    nvg::BeginPath();
    nvg::Rect(solidEndPoint, screenHeight - 50, fadeEndPoint, screenHeight);
    nvg::FillPaint(fadeGradient);
    nvg::Fill();
    nvg::ClosePath();
}

vec3 get_Normalized_Color(vec3 color)
{
    return vec3(color.x / 255.0, color.y / 255.0, color.z / 255.0);
}

float get_Adjusted_Opacity(float baseOpacity)
{
    float adjustedOpacity = baseOpacity + COTD_Gradient_Opacity_Adjustment;

    if (adjustedOpacity > 1.0) {
        adjustedOpacity = 1.0;
    } else if (adjustedOpacity < 0.0) {
        adjustedOpacity = 0.0;
    }

    return adjustedOpacity;
}
*/