bool replay;

uint ReactorLevel;
uint ReactorType;

int CountdownTime = 0;
uint PreviousTime = Time::get_Now();

bool IsOnConcrete = false;
bool WasOnConcrete = false;

uint PreviousReactorLevel;
uint PreviousReactorType;

uint PreviousFRMaterial;
uint PreviousFLMaterial;
uint PreviousRRMaterial;
uint PreviousRLMaterial;

float FRDamperLen;
float FLDamperLen;
float RRDamperLen;
float RLDamperLen;

bool TopContact;

float aimPitch = 0.0;
float Speed = 0.0;

float InputIsBrake;
float InputIsGass;

bool IsGrounded;

float ReactorFinalCountdown;

vec4 fillColor;

vec3 WorldPoss;

float worldPossX;
float worldPossY;
float worldPossZ;
float oldWorldPossX;
float oldWorldPossY;
float oldWorldPossZ;


bool isReactorLevelZero;

float noGas;
float forceGas;
float noBrakes;
float noSteering;
float noGrip;

int currentRaceTime = -1;
int previousRaceTime = -1;



void Render() {
    auto app = cast<CTrackMania@>(GetApp());

        auto playground = cast<CSmArenaClient@>(app.CurrentPlayground);
        if (playground is null) return;

        if (
            playground.GameTerminals.Length != 1 ||
            playground.UIConfigs.Length == 0
        ) return;

        auto scene = cast<ISceneVis@>(app.GameScene);
        if (scene is null) return;

        CSceneVehicleVis@ vis;
        auto player = cast<CSmPlayer@>(playground.GameTerminals[0].GUIPlayer);
        if (player !is null) {
            @vis = VehicleState::GetVis(scene, player);
            replay = false;
        } else {
            @vis = VehicleState::GetSingularVis(scene);
            replay = true;
        }
        if (vis is null) return;

        auto arena = cast<CSmArena@>(playground.Arena);
        if (arena is null) return;

        auto sequence = playground.UIConfigs[0].UISequence;
        if (
            !(sequence == CGamePlaygroundUIConfig::EUISequence::Playing) &&
            !(sequence == CGamePlaygroundUIConfig::EUISequence::UIInteraction && replay)
        ) return;

        RenderDisplay(vis.AsyncState);
        MainDingsBoms(vis.AsyncState);


        // TODO: Check for paused: "app.PlaygroundScript.Interface.ArenaNow"
}

void DistanceFromOrigin() {
    CTrackMania@ app = cast<CTrackMania>(GetApp());
    if (app !is null) {
        auto playground = cast<CSmArenaClient>(app.CurrentPlayground);
        if (playground !is null && playground.Arena.Players.Length > 0) {
            auto script = cast<CSmScriptPlayer>(playground.Arena.Players[0].ScriptAPI);
            if (script !is null) {

                previousRaceTime = currentRaceTime;
                currentRaceTime = script.CurrentRaceTime;

                worldPossX = script.Position.x;
                worldPossY = script.Position.y;
                worldPossZ = script.Position.z;

                if (ReactorLevel != 0 && isReactorLevelZero) {
                    oldWorldPossX = worldPossX; 
                    oldWorldPossY = worldPossY;
                    oldWorldPossZ = worldPossZ;

                    worldPossX = WorldPoss.x;
                    worldPossY = WorldPoss.y;
                    worldPossZ = WorldPoss.z;

                    isReactorLevelZero = false;
                }

                else if (ReactorLevel == 0 && !isReactorLevelZero) {
                    oldWorldPossX = worldPossX;
                    oldWorldPossY = worldPossY;
                    oldWorldPossZ = worldPossZ;

                    worldPossX = WorldPoss.x;
                    worldPossY = WorldPoss.y;
                    worldPossZ = WorldPoss.z;

                    isReactorLevelZero = true;
                }

                forceGas = script.HandicapForceGasDuration;
                noBrakes = script.HandicapNoBrakesDuration;
                noGas = script.HandicapNoGasDuration;
                noGrip = script.HandicapNoGripDuration;
                noSteering = script.HandicapNoSteeringDuration;
            }
        }
    }
}


void MainDingsBoms(CSceneVehicleVisState@ state) {
    try {
        DistanceFromOrigin();

        ReactorFinalCountdown = Dev::GetOffsetFloat(state, 380);

        uint newReactorLevel = uint(state.ReactorBoostLvl);
        uint newReactorType  = uint(state.ReactorBoostType);
        
        auto FRMaterial = state.FLGroundContactMaterial;
        auto FLMaterial = state.FRGroundContactMaterial;
        auto RRMaterial = state.RRGroundContactMaterial;
        auto RLMaterial = state.RLGroundContactMaterial;

        auto InputIsGass = state.InputGasPedal;
        auto InputIsBrake = state.InputBrakePedal;

        auto IsGrounded = state.IsGroundContact;

        // print(FRMaterial + " " + FLMaterial + " " + RRMaterial + " " + RLMaterial);
        // print(InputIsBrake);

// 
// 
// I am deeply sorry Miss (I'm assuming, or any one else for that matter) for what I am about to do to your eyes... Imagine following coding conventions... 
// 
// 
        if ((
                (newReactorLevel != 0 or newReactorType != 0) and (ReactorLevel == 0 and ReactorType == 0)
            ) or (
                (
                    (
                        FRMaterial == 4 or FLMaterial == 4 or RRMaterial == 4 or RLMaterial == 4 or 
                        FRMaterial == 9 or FLMaterial == 9 or RRMaterial == 9 or RLMaterial == 9
                        
                    ) and (
                    
                        FRMaterial == PreviousFRMaterial or FLMaterial == PreviousFLMaterial or RRMaterial == PreviousRRMaterial or RLMaterial == PreviousRLMaterial
                    
                    ) and (

                        worldPossX < (oldWorldPossX + 32) && worldPossX > (oldWorldPossX - 32) &&
                        worldPossY < (oldWorldPossY + 32) && worldPossY > (oldWorldPossY - 32) &&
                        worldPossZ < (oldWorldPossZ + 32) && worldPossZ > (oldWorldPossZ - 32)
                        
                    )   
                ) or (
                    (
                        (FRMaterial == 0) or (FLMaterial == 0) or (RRMaterial == 0) or (RLMaterial == 0)
                    ) 
                    // Currently doesn't work
                    // and 
                    // (
                    //     (state.IsTurbo) or 
                    //     ((state.SimulationTimeCoef < 1.01 ) and (state.SimulationTimeCoef > 0.99 )) or 
                    //     (forceGas != 0) or 
                    //     (noBrakes != 0) or 
                    //     (noGrip != 0) or 
                    //     (noSteering != 0) or 
                    //     (noGas != 0)
                    // )

                    // big doesn't work (under)
                    // and 
                    // (
                    //     worldPossX < (oldWorldPossX + 2.5) && worldPossX > (oldWorldPossX - 2.5) &&
                    //     worldPossY < (oldWorldPossY + 2.5) && worldPossY > (oldWorldPossY - 2.5) &&
                    //     worldPossZ < (oldWorldPossZ + 2.5) && worldPossZ > (oldWorldPossZ - 2.5)
                    // )
                )
            
                
                /*
                // FIXME:
            ) or (
                // Check for reactor gate/ring up (standing still?)
                
                (
                    FRDamperLen > 0.150 or 
                    FLDamperLen > 0.150 or 
                    RRDamperLen > 0.150 or 
                    RLDamperLen > 0.150
                ) and (
                    (!TopContact)
                ) and (
                    (Speed < 10 and Speed > -5) 
                ) and (
                    (ReactorLevel == 1) or (ReactorLevel == 2)
                ) and (
                    ((InputIsBrake == 0 and InputIsGass == 0))
                ) and (
                    (IsGrounded)
                )
                */
            ) or ( 
                newReactorType != PreviousReactorType
            ) or (
                newReactorLevel != PreviousReactorLevel
            )
            ) {
            if (newReactorLevel != 0) {
                if (ReactorFinalCountdown == 0.01 or ReactorFinalCountdown == 0.05) {
                    CountdownTime = 950;
                } else {
                    CountdownTime = 6000;
                }
            } else {
                CountdownTime = 0;
            }
        }

        if (ReactorFinalCountdown == 0 && ReactorLevel != 0 && CountdownTime <= 1030 && CountdownTime >= 980) {
            CountdownTime = 1029;
        }
        
        if (ReactorFinalCountdown >= 0.001 && ReactorFinalCountdown <= 0.051) {
            CountdownTime = 950;
        }

        if (FRMaterial != 4 && FRMaterial != 9 && FRMaterial != 80) {
            PreviousFRMaterial = FRMaterial;
        }
        if (FLMaterial != 4 && FLMaterial != 9 && FLMaterial != 80) {
            PreviousFLMaterial = FLMaterial;
        }
        if (RRMaterial != 4 && RRMaterial != 9 && RRMaterial != 80) {
            PreviousRRMaterial = RRMaterial;
        }
        if (RLMaterial != 4 && RLMaterial != 9 && RLMaterial != 80) {
            PreviousRLMaterial = RLMaterial;
        }
        

        ReactorLevel = newReactorLevel;
        ReactorType  = newReactorType;
        PreviousReactorLevel = newReactorLevel;
        PreviousReactorType  = newReactorType;

        CTrackMania@ app = cast<CTrackMania>(GetApp());
        if (app !is null) {
            auto playground = cast<CSmArenaClient>(app.CurrentPlayground);
            if (playground !is null && playground.Arena.Players.Length > 0) {
                auto script = cast<CSmScriptPlayer>(playground.Arena.Players[0].ScriptAPI);
                if (script !is null) {
                    uint CurrentTime = Time::get_Now();

                    if (previousRaceTime != currentRaceTime) {
                        if (CountdownTime > 0) {
                            CountdownTime -= CurrentTime - PreviousTime;
                            if (CountdownTime < 0) CountdownTime = 0;
                        }
                    }
                    PreviousTime = CurrentTime;
                    }
            }
        }
    } catch { }
}